package com.jiuqi.syntax;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

public class CommonData implements Cloneable {
  public static int CD_NEW_COUNT = 0;
  
  public static int CD_LIVE_COUNT = 0;
  
  public static final int NULL_TYPE = 0;
  
  public static final int INT_TYPE = 1;
  
  public static final int REAL_TYPE = 2;
  
  public static final int STRING_TYPE = 3;
  
  public static final int EXP_TYPE = 4;
  
  public static final int BOOL_TYPE = 5;
  
  public static final int DATE_TYPE = 6;
  
  public static final int MEMO_TYPE = 7;
  
  public static final int OBJECT_TYPE = 8;
  
  public static final int DECIMAL_TYPE = 10;
  
  public int type = 0;
  
  public boolean isNull = false;
  
  public int cdInt = 0;
  
  public double cdReal = 0.0D;
  
  public String cdString = "";
  
  public boolean cdBool = false;
  
  public Calendar cdDate = null;
  
  public Object cdObject = null;
  
  public BigDecimal cdDecimal = null;
  
  public double getIntRealValue() {
    if (this.type == 1)
      return this.cdInt; 
    if (this.type == 2)
      return this.cdReal; 
    return 0.0D;
  }
  
  public CommonData() {
    CD_NEW_COUNT++;
    CD_LIVE_COUNT++;
  }
  
  public Object clone() {
    com.jiuqi.syntax.CommonData d = new com.jiuqi.syntax.CommonData();
    assignTo(d);
    return d;
  }
  
  public void assign(com.jiuqi.syntax.CommonData source) {
    this.type = source.type;
    this.isNull = source.isNull;
    initNullValue();
    if (!this.isNull)
      switch (this.type) {
        case 1:
          this.cdInt = source.cdInt;
          break;
        case 2:
          this.cdReal = source.cdReal;
          break;
        case 3:
          this.cdString = source.cdString;
          break;
        case 4:
          this.cdString = source.cdString;
          break;
        case 5:
          this.cdBool = source.cdBool;
          break;
        case 6:
          this.cdDate = source.cdDate;
          break;
        case 7:
          this.cdObject = source.cdObject;
        case 8:
          this.cdObject = source.cdObject;
          break;
        case 10:
          this.cdDecimal = source.cdDecimal;
          break;
      }  
  }
  
  public void assignTo(com.jiuqi.syntax.CommonData dest) {
    dest.assign(this);
  }
  
  public void initValue() {
    switch (this.type) {
      case 1:
        this.cdInt = 0;
        break;
      case 2:
        this.cdReal = 0.0D;
        break;
      case 3:
        this.cdString = "";
        break;
      case 4:
        this.cdString = "";
        break;
      case 5:
        this.cdBool = false;
        break;
      case 6:
        this.cdDate = null;
        break;
      case 7:
        this.cdObject = null;
        break;
      case 8:
        this.cdObject = null;
        break;
      case 10:
        this.cdDecimal = new BigDecimal(0);
        break;
    } 
  }
  
  public void initNullValue() {
    if (this.isNull)
      initValue(); 
  }
  
  public int compareTo(com.jiuqi.syntax.CommonData other) {
    return compareTo(other, 0.0D);
  }
  
  public final int compareTo(com.jiuqi.syntax.CommonData other, double diffValue) {
    if (other == null)
      return 255; 
    if (this.type != other.type)
      return 255; 
    if (this.isNull && other.isNull)
      return 0; 
    if (this.isNull != other.isNull) {
      initNullValue();
      other.initNullValue();
    } 
    if (operators[this.type] == null)
      return 255; 
    return operators[this.type].compare(this, other, diffValue);
  }
  
  public boolean equals(com.jiuqi.syntax.CommonData other) {
    return (compareTo(other, 0.0D) == 0);
  }
  
  public boolean equals(com.jiuqi.syntax.CommonData other, double diffValue) {
    return (compareTo(other, diffValue) == 0);
  }
  
  public String toString() {
    String s = new String();
    switch (this.type) {
      case 0:
        s = "";
        break;
      case 1:
        s = String.valueOf(this.cdInt);
        break;
      case 2:
        s = String.valueOf(this.cdReal);
        break;
      case 3:
        s = this.cdString;
        break;
      case 4:
        s = this.cdString;
        break;
      case 5:
        s = String.valueOf(this.cdBool);
        break;
      case 6:
        if (this.cdDate == null) {
          s = "";
          break;
        } 
        s = this.cdDate.toString();
        break;
      case 7:
        s = "";
        break;
      case 8:
        s = "";
        break;
      case 10:
        if (this.cdDecimal == null) {
          s = "";
          break;
        } 
        s = this.cdDecimal.toString();
        break;
    } 
    return s;
  }
  
  public void setDateValue(Date dateValue) {
    this.type = 6;
    this.isNull = (dateValue == null);
    if (!this.isNull && this.cdDate == null)
      this.cdDate = new GregorianCalendar(); 
    if (dateValue != null) {
      this.cdDate.setTime(dateValue);
    } else if (this.cdDate != null) {
      this.cdDate.clear();
    } 
  }
  
  public Calendar getValidcdDate() {
    if (this.cdDate == null) {
      this.cdDate = Calendar.getInstance();
      this.cdDate.getTime().setTime(0L);
      this.cdDate.set(1, 1899);
      this.cdDate.set(2, 1);
      this.cdDate.set(5, 1);
    } 
    return this.cdDate;
  }
  
  protected void finalize() throws Throwable {
    CD_LIVE_COUNT--;
    super.finalize();
  }
  
  protected static final DataOperator[] operators = new DataOperator[16];
  
  static {
    operators[0] = (DataOperator)new Object();
    operators[1] = (DataOperator)new Object();
    operators[2] = (DataOperator)new Object();
    operators[3] = (DataOperator)new Object();
    operators[4] = operators[3];
    operators[5] = (DataOperator)new Object();
    operators[6] = (DataOperator)new Object();
    operators[10] = (DataOperator)new Object();
  }
}
